/*
 * FileSizeFilter class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util.file;

import java.io.File;
import java.io.FileFilter;

/**
 * ファイル・サイズを条件とするファイル・フィルタ・クラス。
 *
 * @author  佐藤隆之.
 * @version $Revision: 1.1.1.1 $, $Date: 2010-10-16 00:03:47 $
 */
public class FileSizeFilter implements FileFilter
{
  /** ファイル・サイズ条件の最小値。 */
  private long sizeFrom_ = -1L;

  /** ファイル・サイズ条件の最大値。 */
  private long sizeTo_ = -1L;

  /**
   * ファイル・サイズ条件の範囲を引数にとるコンストラクタ。
   * <br>
   * 負の値を設定した場合は、その値を条件として使用しない。
   * <br>
   * 引数がいずれも負の値ではなく、最小値と最大値の指定が逆だった場合は、
   * 入れ替えて設定する。
   *
   * @param  sizeFrom ファイル・サイズ条件の最小値。
   * @param  sizeTo   ファイル・サイズ条件の最大値。
   */
  public FileSizeFilter(long sizeFrom, long sizeTo)
  {
    if (sizeFrom >= 0 && sizeTo >= 0) {
      if (sizeFrom <= sizeTo) {
        sizeFrom_ = sizeFrom;
        sizeTo_ = sizeTo;
      }
      else {
        sizeFrom_ = sizeTo;
        sizeTo_ = sizeFrom;
      }
    }
    else {
      sizeFrom_ = (sizeFrom < 0L) ? -1L : sizeFrom;
      sizeTo_ = (sizeTo < 0L) ? -1L : sizeTo;
    }
  }

  /**
   * 指定されたファイルのサイズが、このオブジェクトの示すサイズの範囲に該当する
   * （境界値を含む）かどうかを判定する。
   *
   * @param  file 判定対象のファイル。
   * @return ファイル・サイズが該当する場合は<tt>true</tt>を返す。
   * @throws AssertionError 引数がヌルの場合（デバッグ・モードのみ）。
   */
  public boolean accept(File file)
  {
    assert (file != null) : "@param:file is null.";

    if (sizeFrom_ >= 0) {
      if (file.length() < sizeFrom_) {
        return false;
      }
    }

    if (sizeTo_ >= 0) {
      if (file.length() > sizeTo_) {
        return false;
      }
    }

    return true;
  }
}

